'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('babel-polyfill');

require('source-map-support/register');

var _getCsv = require('get-csv');

var _getCsv2 = _interopRequireDefault(_getCsv);

var _soapAsPromised = require('soap-as-promised');

var _soapAsPromised2 = _interopRequireDefault(_soapAsPromised);

require('date-format-lite');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PUBLISHER_SERVICE_WSDL_URL = 'http://api.affiliatewindow.com/v6/AffiliateService?wsdl';
var PRODUCT_SERVE_WSDL_URL = 'http://v3.core.com.productserve.com/ProductServeService.wsdl';

var AffiliateWindow = function () {
	function AffiliateWindow(_ref) {
		var publisherId = _ref.publisherId;
		var apiPassword = _ref.apiPassword;
		var productServeApiKey = _ref.productServeApiKey;
		var promotionsId = _ref.promotionsId;
		(0, _classCallCheck3.default)(this, AffiliateWindow);
		this.config = {
			publisherId: '',
			apiPassword: '',
			productServeApiKey: '',
			promotionsId: ''
		};

		this.config = (0, _assign2.default)({}, this.config, {
			publisherId: publisherId,
			apiPassword: apiPassword,
			productServeApiKey: productServeApiKey,
			promotionsId: promotionsId
		});
	}

	(0, _createClass3.default)(AffiliateWindow, [{
		key: 'connect',
		value: function connect(url) {
			var _this = this;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
				var _config, iId, sPassword, sApiKey, client;

				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_config = _this.config;
								iId = _config.publisherId;
								sPassword = _config.apiPassword;
								sApiKey = _config.productServeApiKey;
								_context.next = 6;
								return _soapAsPromised2.default.createClient(url);

							case 6:
								client = _context.sent;

								client.addSoapHeader({
									UserAuthentication: {
										iId: iId,
										sPassword: sPassword,
										sApiKey: sApiKey,
										sType: 'affiliate'
									}
								});
								return _context.abrupt('return', client);

							case 9:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this);
			}))();
		}
	}, {
		key: 'getMerchantsSimple',
		value: function getMerchantsSimple() {
			var _this2 = this;

			var _ref3 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref3$joined = _ref3.joined;
			var joined = _ref3$joined === undefined ? true : _ref3$joined;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
				var client, result, _result$getMerchantLi, getMerchantListReturn, _getMerchantListRetur, Merchant;

				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.next = 2;
								return _this2.connect(PUBLISHER_SERVICE_WSDL_URL);

							case 2:
								client = _context2.sent;
								_context2.next = 5;
								return client.getMerchantList(joined ? { sRelationship: 'joined' } : {});

							case 5:
								result = _context2.sent;
								_result$getMerchantLi = result.getMerchantListReturn;
								getMerchantListReturn = _result$getMerchantLi === undefined ? {} : _result$getMerchantLi;
								_getMerchantListRetur = getMerchantListReturn.Merchant;
								Merchant = _getMerchantListRetur === undefined ? [] : _getMerchantListRetur;
								return _context2.abrupt('return', Merchant);

							case 11:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, _this2);
			}))();
		}
	}, {
		key: 'getMerchants',
		value: function getMerchants() {
			var _this3 = this;

			var _ref5 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref5$joined = _ref5.joined;
			var joined = _ref5$joined === undefined ? true : _ref5$joined;

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
				var merchants, aMerchantIds, client, promises, dataResult, data;
				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								_context3.next = 2;
								return _this3.getMerchantsSimple({ joined: joined });

							case 2:
								merchants = _context3.sent;
								aMerchantIds = merchants.map(function (merchant) {
									return merchant.iId;
								});
								_context3.next = 6;
								return _this3.connect(PUBLISHER_SERVICE_WSDL_URL);

							case 6:
								client = _context3.sent;
								promises = aMerchantIds.map(function (id) {
									return client.getCommissionGroupList({ iMerchantId: id });
								});
								_context3.next = 10;
								return _promise2.default.all(promises);

							case 10:
								dataResult = _context3.sent;
								data = dataResult.map(function (data) {
									return (data.getCommissionGroupListReturn || {}).CommissionGroup || [];
								});
								return _context3.abrupt('return', merchants.map(function (merchant, index) {
									var commissionGroups = data[index] ? Array.isArray(data[index]) ? data[index] : [data[index]] : [];
									commissionGroups = commissionGroups.map(function (group) {
										return (0, _assign2.default)({}, group, {
											fPercentage: typeof group.fPercentage === 'string' ? +group.fPercentage : group.fPercentage,
											mAmount: group.mAmount ? (0, _assign2.default)({}, group.mAmount, {
												dAmount: +group.mAmount.dAmount
											}) : null
										});
									});

									return (0, _assign2.default)({}, merchant, {
										iId: +merchant.iId,
										aCommissionGroups: commissionGroups
									});
								}));

							case 13:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, _this3);
			}))();
		}
	}, {
		key: 'getVouchers',
		value: function getVouchers() {
			var _this4 = this;

			var _config2 = this.config;
			var publisherId = _config2.publisherId;
			var promotionsId = _config2.promotionsId;


			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4() {
				var csv;
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.next = 2;
								return (0, _getCsv2.default)('https://darwin.affiliatewindow.com/export-promotions/' + publisherId + '/' + promotionsId + '?promotionType=voucher&categoryIds=&regionIds=&advertiserIds=&membershipStatus=joined&promotionStatus=');

							case 2:
								csv = _context4.sent;
								return _context4.abrupt('return', csv.map(function (voucher) {
									return {
										id: voucher['Promotion ID'],
										iMerchantId: voucher['Advertiser ID'],
										sCode: voucher.Code,
										sDescription: voucher.Description,
										sUrl: voucher['Deeplink Tracking'],
										sStartDate: voucher.Starts.date("YYYY-MM-DD hh:mm:ss"),
										sEndDate: voucher.Ends.date("YYYY-MM-DD hh:mm:ss")
									};
								}));

							case 4:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, _this4);
			}))();
		}

		// TODO:

	}, {
		key: 'getLinks',
		value: function getLinks() {}
	}, {
		key: 'getTransactions',
		value: function getTransactions() {
			var _this5 = this;

			var _ref8 = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

			var _ref8$startDate = _ref8.startDate;
			var startDate = _ref8$startDate === undefined ? new Date(Date.now() - 365 * 1000 * 60 * 60 * 24) : _ref8$startDate;
			var _ref8$endDate = _ref8.endDate;
			var endDate = _ref8$endDate === undefined ? new Date() : _ref8$endDate;

			var dateRangeInDays = (endDate - startDate) / (1000 * 60 * 60 * 24);
			var numberOf30DayRanges = Math.ceil(dateRangeInDays / 30);
			var index = 0;
			var promises = [];

			return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5() {
				var client, startDateToUse, endDateToUse, resultsData, results;
				return _regenerator2.default.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								_context5.next = 2;
								return _this5.connect(PUBLISHER_SERVICE_WSDL_URL);

							case 2:
								client = _context5.sent;


								for (; index < numberOf30DayRanges; index = index + 1) {
									startDateToUse = new Date(startDate.getTime() + index * (30 * 1000 * 60 * 60 * 24));
									endDateToUse = new Date(startDate.getTime() + (index + 1) * (30 * 1000 * 60 * 60 * 24));

									if (endDateToUse > endDate) {
										endDateToUse = endDate;
									}

									// WARNING: only returns 1000 transactions for any given 30-day period
									promises.push(client.getTransactionList({
										dStartDate: startDateToUse.toISOString(),
										dEndDate: endDateToUse.toISOString(),
										sDateType: 'transaction',
										iLimit: 1000
									}));
								}

								_context5.next = 6;
								return _promise2.default.all(promises);

							case 6:
								resultsData = _context5.sent;
								results = resultsData.map(function (result) {
									var _result$getTransactio = result.getTransactionListReturn;
									var getTransactionListReturn = _result$getTransactio === undefined ? {} : _result$getTransactio;

									var _ref10 = getTransactionListReturn || {};

									var _ref10$Transaction = _ref10.Transaction;
									var Transaction = _ref10$Transaction === undefined ? [] : _ref10$Transaction;

									return Array.isArray(Transaction) ? Transaction : [Transaction];
								});
								return _context5.abrupt('return', results.reduce(function (prev, curr) {
									return prev.concat(curr);
								}, []));

							case 9:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, _this5);
			}))();
		}
	}]);
	return AffiliateWindow;
}();

exports.default = AffiliateWindow;